SHEBANG
# Copyright @BABOLO (C)2002..2008 http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: up.m4,v 1.1.2.1 2009/01/01 05:49:50 babolo Exp $

JNTROSTUP(spamooborona1024,,dnl
,dnl
# jailup ${inclass} dir jailname jailaddr [uid [gid [port [out]]]]
#     where dir relative to ${JAILUPDIR} and ${JAILRODIR}
#     port - to listen on
#     out - IP:port to send mail to
# ${genclass} from base system used
# Default genclass is \"${genclass}\".
dnl
)

jdir="${1}"
jailsname="${2}"
jailsaddr="${3}"
juid="${4:-65538}"
jgid="${5:-65538}"
port="${6:-25}"
out="${7:-127.0.0.1:25}"
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"

${mkdir} "${main_dir}" "${conf_dir}/spamooborona"
${up_mdir} "${main_dir}" ${MTREE}
ETCOPY(host.conf hosts resolv.conf protocols services)
${up_genlist} usr/lib/ ${MTREE} | ${up_shlib} "${main_dir}/usr/lib"

${up_conf} "${conf_dir}/spamooborona/" "${this}/" <<- "EOF"
	spam.ini
EOF

${up_shlib} "${main_dir}/usr/lib" <<- EOF
	${this}/libstdc++.so.6
	${this}/libgcc_s.so.1
EOF

${up_libexe} "${main_dir}/usr/libexec" <<- EOF
	${this}/sp-proxy
	ld-elf.so.1
EOF

${up_acc} gr "${conf_dir}" <<- EOF
	wheel:*:0:root
	nogroup:*:65533:
	nobody:*:65534:
	souser:*:${jgid}:
EOF

${up_acc} pwt "${conf_dir}" <<- EOF
	root:*:0:0::0:0:Charlie &:/:/nonexistent
	nobody:*:65534:65534::0:0:Unprivileged user:/nonexistent:/nonexistent
	souser:*:${juid}:${jgid}::0:0:spamooborona:/var/spamooborona:/bin/sh
EOF

${cat} << EOF >> "${JAILUPRC}"
#${genclass}	${inclass}	${jdir}	${jailsname}	${jailsaddr}	0	${juid}	${jgid}	${port}	${out}
EOF

${mtree} -Ueqxp "${main_dir}" -f ${MTREE}
${mtree} -Ueqxp "${conf_dir}" << "EOF"
/set type=file uname=root gname=wheel mode=0644 flags=none
.			type=dir mode=0755
    group
    master.passwd	mode=0600
    master.template	mode=0600
    passwd
    protocols
    pwd.db
    resolv.conf
    services
    spwd.db		mode=0600
    spamooborona	type=dir mode=0755
        spam.ini
    ..
..
EOF
      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${up_adc} "${etcdir}/fstab" <<- EOF
	#/null			${main_dir}/dev	null	ro,noexec	0 0
	#${conf_dir}		${main_dir}/etc	null	ro,nodev,noexec	0 0
EOF
      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
